import processing.serial.*; // Bibliothek für serielle Kommunikation
import java.io.IOException;
Serial Port; 
 //Varieblen als String definieren
String breiteX = "";
String laengeZ = "";
String hoeheY = "";
String daten = "";
float X, Y, Z; // float Variablen definieren, mit denen später zur Objektdarstellung gearbeitet wird
//Indizes definieren, die dem Zuschneiden vom String dienen, der Datenübertragung
int index1 = 0;
int index2 = 0;
int index3 = 0;

 
int f = 20; //Variable Faktor, damit werden die Maße des Objekts verzwanzigfacht, damit es nicht zu klein auf dem Bildschirm erscheint
float rotX, rotY;
void setup() {
  size(1200, 800, OPENGL);
 
  String portName = Serial.list()[Serial.list().length-1]; //den zuletzt geöffneten Port verwenden
  Port = new Serial(this, portName, 9600);
}
 
void draw() {  
  background(32); // Schwarzer Hintergrund
  lights(); // Schatten
 
  fill(#FF9F03); //Farbe orange
  noStroke();
 
  serial(Port); //Funktion aufrufen
  translate(width/2, height/2); //Objekt in Bildmitte schieben
  rotateX(rotX);
  rotateY(-rotY); 
  box(X * f, Y* f, Z * f); //Maße werden mit einem vorher definierten Faktor multipliziert um das Objekt später gut erkennen zu können
  drawText(); //Funktion zur Maße des Objekts aufrufen, ausführen
}
 
void mouseDragged() { //Funktion um mit der Maus das Objekt zu drehen
  rotY -= (mouseX - pmouseX) * 0.01;
  rotX -= (mouseY - pmouseY) * 0.01;
}
 
void drawText() { //Funktion die Maße des Objekts ausgibt
 
  noStroke();
 
  fill(98, 245, 31, 67); //Textfarbe grün
  textSize(30); //Textgröße
  //Textposition befindet sich oben rechts
  text("Breite: " + breiteX + " cm", 300, -280, 0);
  text("Länge: " + laengeZ + " cm", 300, -240, 0);
  text("Höhe: " + hoeheY + " cm", 300, -200, 0);
}
 
void serial (Serial Port) { // Anfangen daten vom seriellen Port einzulesen
  if (Port.available() > 0) {
    daten = Port.readStringUntil(';'); // lese Daten, den String, bis zum Semikolon
    daten = daten.substring(0, daten.length()-1); // lese von der Stelle "0" bis zur Leztten Stelle vom String
    System.out.println(daten.toString());
    System.out.println(daten.length()); // daten werden in einen String formatiert und ausgegeben
    index1 = daten.indexOf(","); // ',' finden, bis zum Komma also alles (Die Breite) ausschneiden und Breite = index1
    System.out.println(index1); // gibt die Indexposition aus, zur Kontrolle
    breiteX= daten.substring(0, index1); // daten von der "0." Stelle lesen und anstelle der variablen index1 speichern (Wert breiteX)
    index2 = daten.substring(index1+1, daten.length()-1).indexOf(",")+index1; //2. ',' finden, vom 1. Komma bis zum 2. ausschneiden (laengeZ)
    System.out.println(breiteX); //Breite wird ausgegeben zur Kontrolle, ob richtig ausgeschnitten
    laengeZ= daten.substring(index1+1, index2+1); //  Länge ist alles zwischen dem 1. und dem 2. Komma
    System.out.println(laengeZ); //Länge wird ausgegeben
    hoeheY = daten.substring(index2+2, daten.length()); // daten von Stelle "index2+2", nach dem 2.Komma, bis zum Ende der Daten ausschneidem, wird dann die Höhe
    System.out.println(daten.length()); //Ausgabe der Höhe
 
    // String Variable in float konvertieren
    X = float(breiteX);
    Z = float(laengeZ);
    Y = float(hoeheY);
  }
}
//Teile vom Code könnten von https://howtomechatronics.com/projects/arduino-radar-project/   sein
